#include "spawn.h"

#include "..\algorithms.h"

void botInfo::gotHelp(Player *p, Command *c)
{
	// List commands

	if (!*c->final)
	{
		sendPrivate(p,"--------Rampage-Bot--------");
		switch (p->access)
		{
		case OP_Duke:
		case OP_Baron:
		case OP_King:
		case OP_Emperor:
		case OP_RockStar:
		case OP_Q:
		case OP_God:
		case OP_Owner:
			{	// Owner-level commands
			}
		case OP_SysOp:
			{	// SysOp-level commands
				sendPrivate(p,"Bot-Sysop Commands: !sendmode [arena/pub] !resetafterflagging [on/off]");
			}
		case OP_SuperModerator:
			{	// SuperModerator-level commands
			}
		case OP_Moderator:
			{	// Moderator-level commands
				sendPrivate(p,"Bot-Mod Commands: !rampagestatus [on/off]");
			}
		case OP_Limited:
			{	// Limited-level commands
			}
		case OP_Player:
			{	// Player-level commands
				if(Enabled)
				{sendPrivate(p,"Player Commands: !spree");}
				else
				{sendPrivate(p,"Player Commands: Disabled");}
			}
		}
		sendPrivate(p,"---------------------------");

		return;
	}

	// Specific command help

	switch (p->access)
	{
	case OP_Duke:
	case OP_Baron:
	case OP_King:
	case OP_Emperor:
	case OP_RockStar:
	case OP_Q:
	case OP_God:
	case OP_Owner:
		{	// Owner-level commands
			
		}
	case OP_SysOp:
		{	// SysOp-level commands
			if (c->checkParam("sendmode"))
			{
				sendPrivate(p,"Command !sendmode [arena/pub]: Change how the bot will print out the spree messages, arena= *arena and pub= normal chat");
			}
			else if(c->checkParam("resetafterflagging"))
			{
				sendPrivate(p,"Command !resetafterflagging [on/off]: If you want the bot to reset the spree after the flagging game, turn this ON");
			}
		}
	case OP_SuperModerator:
		{	// SuperModerator-level commands
			
		}
	case OP_Moderator:
		{	// Moderator-level commands
			if (c->checkParam("rampagestatus"))
			{
				sendPrivate(p,"Command !rampagestatus [on/off]: Turns on or off the rampage bot!");
			}
			
		}
	case OP_Limited:
		{	// Limited-level commands
		}
	case OP_Player:
		{	// Player-level commands
			if (c->checkParam("spree"))
			{
				sendPrivate(p, "Command !spree: Prints how many kills you have had since your last death and how many kills needed for the next spree level");
			}
		}
	}
}

void botInfo::gotCommand(Player *p, Command *c)
{
	if (!p) return;
	if (!c) return;

	switch (p->access)
	{
	case OP_Duke:
	case OP_Baron:
	case OP_King:
	case OP_Emperor:
	case OP_RockStar:
	case OP_Q:
	case OP_God:
	case OP_Owner:
		{	// Owner-level commands
		}
	case OP_SysOp:
		{	// SysOp-level commands
			if(c->check("sendmode"))
			{
				String Mode= c->final; //get final portion of string

				if(Mode.IsEmpty()) //if its empty
				{
					Mode= "Send Mode: ";
					if(SendArena)
					{Mode+= "Arena";}
					else
					{Mode+= "Public Chat";}
				}
				else 
				{
					if(Mode == "arena") 
					{
						if(SendArena)
						{Mode= "Send mode is already set to Arena";}
						else
						{
							SendArena =true;
							Mode= "Send mode set to Arena Successfully";
						}
					}
					else 
					{
						if(Mode == "pub")
						{
							if(SendArena)
							{	
								SendArena=false;
								Mode= "Send Mode set to Public Successfully";
							}
							else
							{Mode= "Send mode is already set to Public";}
						}
						else 
						{Mode= "Invalid command for !sendmode , use ON or OFF. Ex- !sendmode arena";}
					}
				}
				sendPrivate(p,Mode);
			}
			else if(c->check("resetafterflagging"))
			{
			
				String Status= c->final; //get final portion of string

				if(Status.IsEmpty()) //if its empty
				{
					Status= "Resets After Flag Game: ";
					if(ResetAfterFlagging)
					{Status+= "ON";}
					else
					{Status+= "OFF";}		
				}
				else //if the string has a command in it
				{
					if(Status == "on") //if the command was on
					{
						//then enable the bot
						if(ResetAfterFlagging)
						{Status= "Reseting After Flag Game Is Already Enabled";}
						else
						{
							ResetAfterFlagging =true;
						
							Status= "Reseting After Flag Game Turned ON Successfully";
						}
					}
					else //if the command was off
					{
						if(Status == "off")//then disable the bot
						{
							if(ResetAfterFlagging)
							{	
								ResetAfterFlagging=false;
								Status= "Reseting After Flag Game Turned OFF Successfully";
							}
							else
							{Status= "Reseting After Flag Game Is Already Disabled";}
						}
						else //if it wasnt a On or OFF command, then it was invalid
						{Status= "Invalid command for !resetafterflagging , use ON or OFF. Ex- !resetafterflagging on";}
					}
				}
				sendPrivate(p,Status);
			}
		}
	case OP_SuperModerator:
		{	// SuperModerator-level commands
		
		}
	case OP_Moderator:
		{	// Moderator-level commands
			if(c->check("rampagestatus"))
			{
				String Status= c->final; //get final portion of string

				if(Status.IsEmpty()) //if its empty
				{
					Status= "Rampage Bot Status: ";
					if(Enabled)
					{Status+= "ON";}
					else
					{Status+= "OFF";}		
				}
				else //if the string has a command in it
				{
					if(Status == "on") //if the command was on
					{
						//then enable the bot
						if(Enabled)
						{Status= "Rampage Bot Is Already Enabled";}
						else
						{
							StatsList.clear();
							Enabled =true;
							for(_listnode <Player> *pl=playerlist->head;pl;pl=pl->next)
							{	
								if(pl->item != me)
								{AddStat(pl->item);}
							}
							Status= "Rampage Bot Turned ON Successfully";
						}
					}
					else //if the command was off
					{
						if(Status == "off")//then disable the bot
						{
							if(Enabled)
							{	
								Enabled=false;
								StatsList.clear();
								Status= "Rampage Bot Turned OFF Successfully";
							}
							else
							{Status= "Rampage Bot Is Already Disabled";}
						}
						else //if it wasnt a On or OFF command, then it was invalid
						{Status= "Invalid command for !rampagestatus , use ON or OFF. Ex- !rampagestatus on";}
					}
				}
				sendPrivate(p,Status);
			}
		}
	case OP_Limited:
		{	// Limited-level commands
		}
	case OP_Player:
		{	// Player-level commands
			if(c->check("spree"))
			{
				String Message;
				if(Enabled)
				{
					PlayerStat* Pstat= GetStat(p);
					if(Pstat != NULL)
					{
						Message=Pstat->Kills;
						Message+=" kills since your last death!";
						sendPrivate(p,Message);

						Uint16 Needed=0xFFFF;
						for(_listnode <RampageItem> *rl=RampageList.head;rl;rl=rl->next)
						{
							
							if((rl->item->Kills - Pstat->Kills > 0) && (rl->item->Kills < Needed))
							{Needed=rl->item->Kills;}
						}
						
						if(Needed != 0xFFFF)
						{
							Message="You need ";
							Message+=Needed-Pstat->Kills;
							Message+=" more kills to reach the next spree level!";
						}
						else
						{
							Message="W00t! You have reached the top of the spree levels!";
						}
					}
					else
					{
						Message="Ewww, you found a bug! Go out of the arena and come back in and see if it fixed itself";
					}
				}	
				else
				{
					Message="Command !spree has been disabled by a moderator";
				}

				sendPrivate(p,Message);
			}
			else if (c->check("about") || c->check("version"))
			{
				sendPrivate(p, "Rampage Plugin v2 1/2 by 50% Packetloss(FiftyPacketloss@socal.rr.com)");
			}
		}
	}
}

void botInfo::gotRemoteHelp(char *p, Command *c, Operator_Level l)
{
	// List commands

	if (!*c->final)
	{
		switch (l)
		{
		case OP_Duke:
		case OP_Baron:
		case OP_King:
		case OP_Emperor:
		case OP_RockStar:
		case OP_Q:
		case OP_God:
		case OP_Owner:
			{	// Owner-level commands
			}
		case OP_SysOp:
			{	// SysOp-level commands
			}
		case OP_SuperModerator:
			{	// SuperModerator-level commands
			}
		case OP_Moderator:
			{	// Moderator-level commands
			}
		case OP_Limited:
			{	// Limited-level commands
			}
		case OP_Player:
			{	// Player-level commands
			}
		}

		return;
	}

	// Specific command help

	switch (l)
	{
	case OP_Duke:
	case OP_Baron:
	case OP_King:
	case OP_Emperor:
	case OP_RockStar:
	case OP_Q:
	case OP_God:
	case OP_Owner:
		{	// Owner-level commands
		}
	case OP_SysOp:
		{	// SysOp-level commands
		}
	case OP_SuperModerator:
		{	// SuperModerator-level commands
		}
	case OP_Moderator:
		{	// Moderator-level commands
		}
	case OP_Limited:
		{	// Limited-level commands
		}
	case OP_Player:
		{	// Player-level commands
		}
	}
}

void botInfo::gotRemote(char *p, Command *c, Operator_Level l)
{
	if (!c) return;

	switch (l)
	{
	case OP_Duke:
	case OP_Baron:
	case OP_King:
	case OP_Emperor:
	case OP_RockStar:
	case OP_Q:
	case OP_God:
	case OP_Owner:
		{	// Owner-level commands
		}
	case OP_SysOp:
		{	// SysOp-level commands
		}
	case OP_SuperModerator:
		{	// SuperModerator-level commands
		}
	case OP_Moderator:
		{	// Moderator-level commands
		}
	case OP_Limited:
		{	// Limited-level commands
		}
	case OP_Player:
		{	// Player-level commands
		}
	}
}
